package rlemaigr.classdiagrameditor.commands;

import org.eclipse.gef.commands.*;
import rlemaigr.classdiagrameditor.model.*;
import org.eclipse.draw2d.geometry.*;

public class CreateClassCommand extends Command
{
	private DiagramModel diagram;
	private ClassModel newClass;
	private Point location;
	private Dimension size;
	
	public CreateClassCommand(DiagramModel diagram, ClassModel newClass, Point location, Dimension size)
	{
		this.newClass = newClass;
		this.location = location;
		this.size = size;
		this.diagram = diagram;
	}
	public void execute()
	{
		newClass.setLocation(location);
		if(size != null)
			newClass.setSize(size);
		diagram.addElement(newClass);
	}
	public void redo()
	{
		diagram.addElement(newClass);
	}
	public void undo()
	{
		diagram.removeElement(newClass);
	}

}
