package rlemaigr.classdiagrameditor.commands;

import org.eclipse.gef.commands.*;
import rlemaigr.classdiagrameditor.model.*;

public class CreateConnectionCommand extends Command
{
	private ClassModel source;
	private ClassModel target;
	private InheritanceModel connection;
	
	public CreateConnectionCommand(ClassModel source, ClassModel target)
	{
		this.source = source;
		this.target = target;
	}
	public void execute()
	{
		connection = new InheritanceModel();
		connection.setSource(source);
		connection.setTarget(target);
	}
	public void redo()
	{
		connection.setSource(source);
		connection.setTarget(target);
	}
	public void undo()
	{
		connection.setSource(null);
		connection.setTarget(null);
	}
	public void setTarget(ClassModel target)
	{
		this.target = target;
	}
}