package rlemaigr.classdiagrameditor.commands;

import org.eclipse.gef.commands.*;
import rlemaigr.classdiagrameditor.model.*;

public class DeleteConnectionCommand extends Command
{
	private InheritanceModel connection;
	private ClassModel source;
	private ClassModel target;

	public DeleteConnectionCommand(InheritanceModel connection)
	{
		this.connection = connection;
	}
	public void execute()
	{
		source = connection.getSource();
		target = connection.getTarget();
		connection.setSource(null);
		connection.setTarget(null);
	}
	public void redo()
	{
		connection.setSource(null);
		connection.setTarget(null);
	}
	public void undo()
	{
		connection.setSource(source);
		connection.setTarget(target);
	}
}
