package rlemaigr.classdiagrameditor.commands;

import org.eclipse.gef.commands.*;
import rlemaigr.classdiagrameditor.model.*;

public class ReconnectTargetCommand extends Command
{
	private ClassModel newTarget;
	private ClassModel oldTarget;
	private InheritanceModel connection;
	
	public ReconnectTargetCommand(ClassModel newSource, InheritanceModel connection)
	{
		this.newTarget = newSource;
		this.connection = connection;
	}
	public void execute()
	{
		oldTarget = connection.getTarget();
		connection.setTarget(newTarget);
	}
	public void redo()
	{
		connection.setTarget(newTarget);
	}
	public void undo()
	{
		connection.setTarget(oldTarget);
	}
}