package rlemaigr.classdiagrameditor.editparts;

import rlemaigr.classdiagrameditor.figures.*;
import rlemaigr.classdiagrameditor.model.*;
import rlemaigr.classdiagrameditor.editpolicies.*;
import org.eclipse.draw2d.IFigure;
import org.eclipse.gef.*;
import java.util.*;
import java.beans.*;

public class AttributeEditPart extends ObjectEditPart
{
	public IFigure createFigure()
	{
		return new AttributeFigure();
	}
	public void refreshVisuals()
	{
		AttributeFigure figure = (AttributeFigure) getFigure();
		AttributeModel model = (AttributeModel) getModel();
		figure.setSignature(model.getVisibility(), model.getType(), model.getIdentifier());
	}
	public List getModelChildren()
	{
		return new ArrayList();
	}
	public void createEditPolicies()
	{
		super.createEditPolicies();
		installEditPolicy(EditPolicy.COMPONENT_ROLE, new ComponentEditPolicyForwardDelete()
		{
		});
	}
	public void propertyChange(PropertyChangeEvent ev)
	{
		if (ev.getPropertyName().equals(AttributeModel.PROPERTY_SIGNATURE_CHANGED))
			refreshVisuals();
		else
			super.propertyChange(ev);
	}
}
