package rlemaigr.classdiagrameditor.editparts;

import org.eclipse.draw2d.*;
import org.eclipse.gef.tools.*;
import org.eclipse.gef.*;
import java.util.*;
import rlemaigr.classdiagrameditor.model.*;
import rlemaigr.classdiagrameditor.editpolicies.*;
import java.beans.*;

public class DiagramEditPart extends ObjectEditPart
{
	private AutomaticRouter router;

	public IFigure createFigure()
	{
		Figure f = new FreeformLayer();
		f.setLayoutManager(new FreeformLayout());
		return f;
	}
	public List getModelChildren()
	{
		DiagramModel model = (DiagramModel) getModel();
		return model.getElements();
	}
	public void createEditPolicies()
	{
		super.createEditPolicies();
		this.installEditPolicy(EditPolicy.LAYOUT_ROLE, new XYLayoutEditPolicyImpl());
	}
	public DragTracker getDragTracker(Request request)
	{
		return new MarqueeDragTracker();
	}
	public void propertyChange(PropertyChangeEvent ev)
	{
		super.propertyChange(ev);
		if (ev.getPropertyName().equals(DiagramModel.PROPERTY_ELEMENT_ADDED))
			refreshChildren();
		else if (ev.getPropertyName().equals(DiagramModel.PROPERTY_ELEMENT_REMOVED))
			refreshChildren();
	}
	public void refreshVisuals()
	{
		ConnectionLayer cLayer = (ConnectionLayer) getLayer(LayerConstants.CONNECTION_LAYER);
		cLayer.setConnectionRouter(getConnectionRouter());
	}

	public AutomaticRouter getConnectionRouter()
	{
		if (router == null)
		{
			router = new FanRouter();
			router.setNextRouter(new BendpointConnectionRouter());
		}
		return router;
	}
}
