package rlemaigr.classdiagrameditor.editpolicies;

import org.eclipse.gef.commands.Command;
import org.eclipse.gef.editpolicies.*;
import org.eclipse.gef.requests.BendpointRequest;
import org.eclipse.draw2d.geometry.*;
import rlemaigr.classdiagrameditor.model.*;
import rlemaigr.classdiagrameditor.commands.*;

public class BendpointEditPolicyImpl extends BendpointEditPolicy
{

	protected Command getCreateBendpointCommand(BendpointRequest request)
	{
		int index = request.getIndex();
		Point loc = request.getLocation();
		InheritanceModel model = (InheritanceModel)getHost().getModel();
		return new CreateBendpointCommand(model, index, loc);
	}

	protected Command getDeleteBendpointCommand(BendpointRequest request)
	{
		int index = request.getIndex();
		InheritanceModel model = (InheritanceModel)getHost().getModel();
		return new DeleteBendpointCommand(model, index);
	}

	protected Command getMoveBendpointCommand(BendpointRequest request)
	{
		int index = request.getIndex();
		Point loc = request.getLocation();
		InheritanceModel model = (InheritanceModel)getHost().getModel();
		return new MoveBendpointCommand(model, index, loc);
	}

}
