package rlemaigr.classdiagrameditor.figures;

import org.eclipse.draw2d.*;
import org.eclipse.swt.graphics.Image;
import org.eclipse.draw2d.geometry.*;

public class AttributeFigure extends Label
{
	private static final Image IMAGE_PUBLIC =
		new Image(null, ClassFigureBorder.class.getResourceAsStream("field_public_obj.gif"));
	private static final Image IMAGE_PRIVATE =
		new Image(null, ClassFigureBorder.class.getResourceAsStream("field_private_obj.gif"));
	private static final Image IMAGE_PROTECTED =
		new Image(null, ClassFigureBorder.class.getResourceAsStream("field_protected_obj.gif"));

	public static final int PUBLIC = 0;
	public static final int PRIVATE = 1;
	public static final int PROTECTED = 2;

	public void setSignature(int visibility, String returnType, String identifier)
	{
		this.setLabelAlignment(Label.LEFT);
		String txt = returnType + " " + identifier;
		setText(txt);
		setIcon(getVisibilityIcon(visibility));
	}
	public Dimension getMinimumSize(int w, int h)
	{
		return new Dimension(0, 0);
	}
	static public Image getVisibilityIcon(int visibility)
	{
		switch (visibility)
		{
			case PUBLIC :
				return IMAGE_PUBLIC;
			case PRIVATE :
				return IMAGE_PRIVATE;
			case PROTECTED :
				return IMAGE_PROTECTED;
			default :
				return IMAGE_PUBLIC;
		}
	}
}