package rlemaigr.classdiagrameditor.figures;

import org.eclipse.draw2d.*;
import org.eclipse.draw2d.geometry.*;


public class ClassFigure extends ScrollPane
{	
	private String className;
	private LabeledBorder labeledBorder;
	private ContentPane contentPane;//classe dfinie ci-dessous.
	
	public ClassFigure()
	{
		this.setHorizontalScrollBarVisibility(ScrollPane.NEVER);
	
		//background:
		setBackgroundColor(ColorConstants.white);
		
		//bord:
		labeledBorder = new ClassFigureBorder();
		ShadowBorder border = new ShadowBorder();
		border.setWidth(3);
		//setBorder(new CompoundBorder(new SimpleRaisedBorder(), new CompoundBorder(new LineBorder(2), labeledBorder)));
		setBorder(new CompoundBorder(border, new CompoundBorder(new LineBorder(1), labeledBorder)));
		
		//contentpane:
		contentPane = new ContentPane();
		getViewport().setContents(contentPane);//Et PAS getViewport().add(contentPane) !! (deux heures de prise de tte)
	}
	
	public void setLabel(String label)
	{
		labeledBorder.setLabel(label);
		revalidate();//pour tre sr mais probablement pas ncessaire.
		repaint();
	}
	public Figure getContentPane()
	{
		return contentPane;
	}
	public void setSpacing(int spacing)
	{
		contentPane.setSpacing(spacing);
	}
}

class ContentPane extends Figure
{
	private ToolbarLayout layout;
	private static final int DEFAULT_SPACING = 5;
	
	public ContentPane()
	{
		layout = new ToolbarLayout(ToolbarLayout.VERTICAL);
		layout.setSpacing(DEFAULT_SPACING);
		layout.setStretchMinorAxis(true);
		setLayoutManager(layout);
	}
	
	public void setSpacing(int spacing)
	{
		layout.setSpacing(spacing);
		revalidate();
	}
	/*
	 * Redfinie de manire renvoyer comme largeur prfre la largeur du viewport dont
	 * cette figure est le contenu et comme hauteur prfre la hauteur prfre "normale".
	 * Comme ViewportLayout donne au contenu du viewport la taille max(taille du viewport,
	 * taille prfre du contenu), le rsultat est que le contenu du viewport a toujours
	 * pour largeur attribue la largeur du viewport. Ca permet de raliser artificiellement
	 * un scrollpane qui n'a d'effet que verticalement. C'est important pour que le feedback
	 * de slection d'un lment intrieur au scrollpane ne s'tende hors du scrollpane.
	 * (pour comprendre, le mieux est de supprimer cette mthode et de voir ce que
	 * a donne sans elle).
	 */
	public Dimension getPreferredSize(int hint, int vint)
	{
		Dimension prefSize = super.getPreferredSize(hint, vint);
		return new Dimension(getParent().getClientArea().width, prefSize.height);
	}
}