package rlemaigr.classdiagrameditor.figures;

import org.eclipse.draw2d.*;
import org.eclipse.draw2d.geometry.Insets;
import org.eclipse.swt.graphics.Color;
import org.eclipse.draw2d.geometry.*;
import org.eclipse.swt.graphics.Image;

import org.eclipse.swt.graphics.FontData;
import org.eclipse.swt.graphics.Font;
import org.eclipse.swt.SWT;

public class ClassFigureBorder extends AbstractLabeledBorder
{
	private Color color;
	public static Image IMAGE = new Image(null, 
	  ClassFigureBorder.class.getResourceAsStream("class_obj.gif"));
	private static final int BORDER_SIZE = 2;
	private static final int LINE_WIDTH = 2;
	private static final int TITLE_BORDER_SIZE = 2;
	private Font font;
	
	public ClassFigureBorder()
	{
		FontData fd = new FontData("Courrier", 10, SWT.BOLD);
		font = new Font(null, fd);
	}
	
	public void paint(IFigure f, Graphics g, Insets insetsFigure)
	{
		if(color != null)
			g.setForegroundColor(color);
		g.setLineWidth(LINE_WIDTH);
		  
		Rectangle area = f.getBounds().getCropped(insetsFigure);
		g.setClip(area);
		Dimension textSize = FigureUtilities.getTextExtents(getLabel(), getFont(f));
		
		Point gauche = area.getLocation().translate(0,(getInsets(f).top-BORDER_SIZE));
		Point droit = gauche.getCopy().translate(area.width,0);
		
		g.drawLine(gauche, droit);
		
		Color bgcolor = g.getBackgroundColor();
		g.setBackgroundColor(ColorConstants.lightBlue);
		g.fillRectangle(area.getLocation().x,
		  area.getLocation().y,
		  area.width,
		  getInsets(f).top - LINE_WIDTH - 1); // - 1 pourquoi ? - 1 parce que !! On ne discute pas !!
		
		/*FontData currentfd = g.getFont()
		FontData fd = new FontData(null, 12,SWT.BOLD);
		Font font = new Font(null, fd);*/
		g.setFont(font);
		/*FontData fd = f.getFont().getFontData()[0];
		g.getFont().
		fd.setStyle(SWT.BOLD);
		g.setFont(g.getFont());*/
		
		Point coinSupGaucheText = area.getLocation().translate((area.getSize().width - textSize.width )/ 2,TITLE_BORDER_SIZE);
		g.drawText(getLabel(), coinSupGaucheText);
		g.drawImage(IMAGE, coinSupGaucheText.translate((-IMAGE.getBounds().width-2), (textSize.height - IMAGE.getBounds().height)/2));
	}
	public Insets calculateInsets(IFigure f)
	{
		Dimension textSize = FigureUtilities.getTextExtents(getLabel(), getFont(f));
		int top = textSize.height + BORDER_SIZE + 2 * TITLE_BORDER_SIZE;
		return new Insets(top, BORDER_SIZE, BORDER_SIZE, BORDER_SIZE);
	}
	public void setColor (Color c)
	{
		color = c;
	}
	public void finalize()
	{
		font.dispose();
	}
}
