package rlemaigr.classdiagrameditor.model;

import java.util.*;

public class ListModel extends ObjectModel
{
	private List elementList;

	public static final String PROPERTY_LIST_MODIFIED = "list modified";

	public ListModel()
	{
		elementList = new ArrayList();
	}
	public void addElement(Object element, int index)
	{
		elementList.add(index, element);
		firePropertyChange(PROPERTY_LIST_MODIFIED, null, null);
	}
	final public void addElement(Object element)
	{
		addElement(element, elementList.size());
	}
	public void removeElement(Object element)
	{
		elementList.remove(element);
		firePropertyChange(PROPERTY_LIST_MODIFIED, null, null);
	}
	public int getIndexOf(Object element)
	{
		return elementList.indexOf(element);
	}
	public int getSize()
	{
		return elementList.size();
	}
	/**
	 * ne pas modifier la liste retourne par cette mthode ou le modle ne notifiera pas !
	 * appeler les mthodes de la classe ListModel  la place.
	 */
	public List getElementList()
	{
		return elementList;
	}
}
