package rlemaigr.classdiagrameditor.model;

import java.beans.*;

import org.eclipse.ui.views.properties.IPropertyDescriptor;
import org.eclipse.ui.views.properties.IPropertySource;

/*
 * Introduit un support pour la notification dans les classes enfants et
 * implmente l'interface IPropertySource.
 */

public class ObjectModel implements IPropertySource
{
	private PropertyChangeSupport listeners;
	private static IPropertyDescriptor [] descriptors;

	public ObjectModel()
	{
		listeners = new PropertyChangeSupport(this);
	}
	
	public void addPropertyChangeListener(PropertyChangeListener listener)
	{
		listeners.addPropertyChangeListener(listener);
	}
	public void removePropertyChangeListener(PropertyChangeListener listener)
	{
		listeners.removePropertyChangeListener(listener);
	}
	protected void firePropertyChange(
		String propertyName,
		Object oldValue,
		Object newValue)
	{
		listeners.firePropertyChange(propertyName, oldValue, newValue);
	}

	public Object getEditableValue()
	{
		return this;
	}
	public IPropertyDescriptor[] getPropertyDescriptors()
	{
		if(descriptors == null)
			descriptors = new IPropertyDescriptor[0];
		return descriptors;
	}
	public Object getPropertyValue(Object propName)
	{
		return null;
	}
	/*final Object getPropertyValue(String propName)
	{
		return null;
	}*/
	public boolean isPropertySet(Object propName)
	{
		return true; //isPropertySet((String) propName);
	}
	/*final boolean isPropertySet(String propName)
	{
		return true;
	}*/
	public void resetPropertyValue(Object propName)
	{
	}
	public void setPropertyValue(Object propName, Object val)
	{
	}
	/*final void setPropertyValue(String propName, Object val)
	{
	}*/
}